__doc__ = """BaseStore initialization module.  """

__version__ = '0.1' # Anything more and it'd be Interesting.  

import BaseStore

def initialize(context): 
    
    try: 
        context.registerClass(
            BaseStore.BaseStore, 
            constructors = (
                BaseStore.manage_addBaseStoreForm,
                BaseStore.manage_addBaseStore),    
            icon = 'item.gif' 
            )
       
    except:
        import sys, traceback, string
        type, val, tb = sys.exc_info()
        sys.stderr.write(string.join(traceback.format_exception(type, val, tb), ''))
        del type, val, tb




