"""

Changes: 3/10/99 Ben Leslie

Hacked around with some stuff to get file to work on my system. May be helpful
generally (I hope).


"""

__version__='$Revision: 1.5 $'[11:-2]


import string
from base64 import decodestring, encodestring
import notimap
import os
imaplib = notimap
from imapUser import imapUser
from Globals import HTMLFile, MessageDialog
from AccessControl.User import BasicUserFolder
from Acquisition import Implicit
from ExtensionClass import Base
import traceback

addIMAPAdapterForm=HTMLFile('addIMAPAdapter',globals())

def addIMAPAdapter(self, title='', imap_server='', imap_port=143, roles='', REQUEST=None):

    """
    Function is called by Zope to create and install a IMAPAdapter
    object.

    """
    n = IMAPAdapter(title, imap_server, imap_port, roles, REQUEST)

    if hasattr(self.aq_base, 'acl_users'):
        return MessageDialog(
               title  ='Item Exists',
               message='This object already contains a User Folder',
               action ='%s/manage_main' % REQUEST['URL1'])

    self._setObject('acl_users', n)
    self.__allow_groups__=self.acl_users

    # return to the parent object's manage_main
    if REQUEST is not None: return self.manage_main(self,REQUEST)

class IMAPAdapter(BasicUserFolder, Implicit, Base):
    """ IMAPAdapter 0.0.2

    The IMAPAdapter is a user database.  It contains management hooks
    so that it can be added to a Zope folder as an 'acl_users'
    database.  It's important public method is validate() which
    returns a Zope user object of type imapUser which can be used to
    access and manage that users imap account.

    For an example of how to use the imapUser API, see the doc string
    for IMAPAdapter.imapUser.imapUser.

    BJL: Changed this to get rid of smtp references

    """

    meta_type = 'IMAPAdapter'
    id = 'acl_users'
    title = 'IMAPAdapter'
    icon = 'misc_/IMAPAdapter/folder'

    isAUserFolder=1

    manage_options=(
        {'label':'Properties', 'action':'manage_main'},
        {'label':'Security',   'action':'manage_access'},
        )

    __ac_permissions__=(
        ('View management screens', ('manage_main', 'manage_tabs', 'manage_workspace')),
        ('Change permissions'     , ('manage_access')             ),
        ('Change IMAPAdapter'     , ('manage_edit')               ),
        )

    manage_main=HTMLFile('properties', globals())

    def __init__(self, title='', imap_server='localhost', imap_port=143, roles='NotMail', REQUEST=None):

        self.users = {}  # this is the cache of users
        self.manage_edit(title, imap_server, imap_port, roles, REQUEST)
        
    def manage_edit(self, title, imap_server, imap_port, roles, REQUEST=None):
        """ Edit the IMAPAdapter Object
        
        """
        self.title=title
        self.imap_server = imap_server
        self.imap_port = imap_port
        self.roles = roles
        
        self.__roles__ = filter(None, map(string.strip, 
                                          string.split(roles, ',')))
        if REQUEST is not None:
            return self.manage_main(self, REQUEST)
        
    def connect(self, imap_server, imap_port):
	        try:
        	    	conn = Connection(imap_server, imap_port, self)
	        except:
			return None
	        # self.conn = conn
        	return conn

    def validate(self, request, auth='', roles=None):
        """ """
        parent=request['PARENTS'][0]

        # Only do basic authentication
        if auth == None:
            return None

        if string.lower(auth[:6])!='basic ':
            return None
        name,password=tuple(string.split(decodestring(string.split(auth)[-1]), ':'))
        if self.users.has_key(name):
            """
            URGENT TODO: Check security of this as it doesn't actually verify password
            again...
            """
            try:
                self.users[name].conn.connection.noop()
            except:
                del self.users[name].conn.connection
                try:
                    c = imaplib.IMAP4(self.imap_server, self.imap_port)
                    c.login(name, password)
                except:
                    return None
                self.users[name].conn.connection = c
            return self.users[name].__of__(self)
        c = imaplib.IMAP4(self.imap_server, self.imap_port)
        try:
            c.login(name, password)
        except:
            c.logout()
            return None

        user = imapUser(name, password, self.roles, self.imap_server, self.imap_port,  '')
        if not user.getConnection():
            # no good
            return None

        user.conn.connection = c

        # Try to authorize user
        if user.allowed(parent, roles):
            self.users[name] = user
            return user.__of__(self)
        return None





