__doc__ = """ImapStore initialization module.  """

__version__ = '0.1' # Anything more and it'd be Interesting.  

import ImapStore

def initialize(context): 
    
    try: 
        context.registerClass(
            ImapStore.ImapStore, 
            constructors = (
                ImapStore.manage_addImapStoreForm,
                ImapStore.manage_addImapStore),    
            icon = 'item.gif' 
            )
       
    except:
        import sys, traceback, string
        type, val, tb = sys.exc_info()
        sys.stderr.write(string.join(traceback.format_exception(type, val, tb), ''))
        del type, val, tb




