__doc__="""

This a a default stupid view which isn't actually
very useful except for testing.
"""

import copy
from Globals import HTMLFile
from Globals import MessageDialog
from Globals import Persistent
from DocumentTemplate.DT_Util import html_quote
from Products.TempStore import FileMessage
import cStringIO
import OFS.SimpleItem
import OFS.Folder
import Acquisition
import string
import AccessControl.Role
from HTML2Body import HTML2Body
import traceback

manage_addObsidianSkinForm = HTMLFile('ObsidianSkinAdd', globals())

def manage_addObsidianSkin(self, id, title='', REQUEST=None):
    """ Add a stupid store product to a folder."""
    self._setObject(id, ObsidianSkin(id, title))
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)

class ObsidianSkin (
                      OFS.Folder.Folder,   # A simple Principia object. Not Obsidianish. 
                      Persistent,            # Make us persistent. Yaah! 
                      Acquisition.Implicit,  # Uh, whatever. 
                      AccessControl.Role.RoleManager, # Security manager. 
                      ):

    def __init__(self, id, title):
        self.id = id
        self.title = title
        self.refresh_docs()
    
    """Base class for all store objects"""
    meta_type='ObsidianSkin'

    manage_main=HTMLFile('manage_main', globals())
    debug=1

    def debugger(self, debugthis):
        pass
        #print 'debugger: %s' % debugthis


    defaultDocs = [
        ('Compose', 'Compose'),
        ('Folder', 'Folder'),
        ('Message', 'Message')]

    def index_html(self, object, REQUEST=None):
        """
        """
        return REQUEST['RESPONSE'].redirect("%s/inbox?skin=Folder" % REQUEST['store'].getURL(REQUEST))

    __call__ = index_html

    manage_options = ( # what management options are there?
        {'label': 'Contents',       'action': 'manage_main'},
        {'label': 'View',       'action': ''}, # defaults to index_html
        {'label': 'Security',   'action': 'manage_access'},
        ) 

    __ac_permissions__=( # what permissions make sense for us? 
	('View management screens', ('manage_tabs','manage_main')),
	('Change permissions',      ('manage_access',)           ),
	('View Skin',            ('index_html', 'folder', 'message', 'compose',)),
	)
    #manage_main = HTMLFile('ObsidianSkinEdit', globals()) # Management Interface
    
    def manage_edit(self, title, REQUEST=None): 
        """does this really need a doc string?"""
        self.title = title
        if REQUEST is not None:
            return MessageDialog(
                title = 'Edited',
                message = "Properties for %s changed." % self.id,
                action = './manage_main',
        )

    def getObsidianList(self, store, REQUEST):
        """
        """
        top = store.getParents(REQUEST)[-1]
        retVal =  self.getObsidians(top, '', 0, REQUEST)
        return retVal

    def getObsidians(self, store, parStr, spacing, REQUEST):
        """
        """
        retVal = []
        store.setFilter('multipart/x-directory', REQUEST)        
        spaces = ''
        for i in range(spacing):
            spaces = spaces + '&nbsp;'
        substores = store.getStores(REQUEST)
        treestr = ''
        depth = 0
        for each in substores:
            depth = depth + 1
            if spacing > 1:
                treestr = spaces + '+&nbsp;&nbsp;'
            retVal = retVal + [('%s/%s' % (parStr, each.id), '%s%s' % (treestr, each.id))] + self.getObsidians(each, "%s/%s" % (parStr, each.id), spacing + 3, REQUEST)
        return retVal

    def skinaction(self, store, REQUEST):
        """
        """
        for method_name in ['delete_message',
                            'deleteCurrentMessage',
                            'goto',
                            'manage_folders',
                            'move_message',
                            'copy_message',
                            'moveCurrentMessage',
                            'copyCurrentMessage',                            
                            'check',
                            'addressbooks',
                            'about',
                            'help',
                            'findit',
                            'sortByFrom',
                            'sortBySubject',
                            'sortByDate',
                            'sortBySize',
                            'composeMessage',
                            'sendMessage',
                            'replyMessage',
                            'replyAllMessage',
                            'forwardMessage',
                            'sendAttachment',
                            'prev_message',
                            'addSendAddrBook',
                            'index',
                            'configure',
                            'next_message']:
            if REQUEST.form.has_key(method_name) or REQUEST.form.has_key("%s.x" % method_name):
                if method_name == 'get_data':
                    return getattr(self, method_name)(store, REQUEST)
                else:
                    return getattr(self, method_name)(store, REQUEST)
        return REQUEST['RESPONSE'].redirect("%s?skin=%s" % (store.getURL(REQUEST), REQUEST.form['skin']))
        return self.render(store, REQUEST)
            
    def goto(self, store, REQUEST):
        """
        """
        RESPONSE = REQUEST['RESPONSE']
        if REQUEST.form['dest'] == store.getURL(REQUEST):
            # Jumping not changing
            if REQUEST.form.has_key('jump'):
                return RESPONSE.redirect("%s?skin=Folder&query_start=%s" %
                                     (REQUEST.form['dest'], REQUEST.form['jump']))
            else:
                return RESPONSE.redirect("%s?skin=Folder" % (REQUEST.form['dest']))
        else:
            """
            top = store.getParents(REQUEST)[-1]
            for each in string.split(REQUEST.form['dest'][1:], '/'):
                top = top.getStore(each, REQUEST)
                tops = top.getParents(REQUEST)
                blerg = ''
                for x in tops[:-1]:
                    blerg = x.id + '/' + blerg
            """
            return RESPONSE.redirect("%s?skin=Folder" % REQUEST.form['dest'])

    def move_message(self, store, REQUEST):
        """ """
        top = store.getParents(REQUEST)[-1]
        for each in string.split(REQUEST.form['dest'][(len(top.getURL(REQUEST)))+1:], '/'):
            top = top.getStore(each, REQUEST)

        marked_uids = []
        for uid in REQUEST.form.keys():
            if REQUEST.form[uid] == 'on':
                    marked_uids = marked_uids + [uid]
        
        for each in marked_uids:
            message = store.getStore(each, REQUEST)
            store.moveMessage(message, top, REQUEST)
        return REQUEST['RESPONSE'].redirect("%s?skin=Folder" % (store.getURL(REQUEST)))

    def copy_message(self, store, REQUEST):
        """ """
        top = store.getParents(REQUEST)[-1]
        for each in string.split(REQUEST.form['dest'][(len(top.getURL(REQUEST)))+1:], '/'):
            top = top.getStore(each, REQUEST)
        marked_uids = []
        for uid in REQUEST.form.keys():
            if REQUEST.form[uid] == 'on':
                marked_uids = marked_uids + [uid]
        for each in marked_uids:
            message = store.getStore(each, REQUEST)
            store.copyMessage(message, top, REQUEST)
        return REQUEST['RESPONSE'].redirect("%s?skin=Folder" % (store.getURL(REQUEST)))

    def delete_message(self, store, REQUEST):
        """ """

        marked_uids = []
        for uid in REQUEST.form.keys():
            if REQUEST.form[uid] == 'on':
                marked_uids = marked_uids + [uid]
                
        for each in marked_uids:
            message = store.getStore(each, REQUEST)
            store.deleteMessage(message, REQUEST)
        return REQUEST['RESPONSE'].redirect("%s?skin=Folder" % (store.getURL(REQUEST)))

    def findit(self, store, REQUEST):
        """
        """
        store.setSearchTerm(REQUEST.form['search'], REQUEST)
        return REQUEST['RESPONSE'].redirect("%s?skin=Folder&query_start=1" % (store.getURL(REQUEST)))

    def sortByX (self, X, store,  REQUEST):
        """
        """
        if store.getSortTerm(REQUEST) == X:
            store.setReverse(REQUEST)
        else:
            store.setSortTerm(X, REQUEST)
            self.setReverse(REQUEST, 0)
        return REQUEST['RESPONSE'].redirect("%s?skin=Folder" % store.getURL(REQUEST))

    def sortBySubject (self, store, REQUEST):
        """
        """
        return self.sortByX('subject', store, REQUEST)

    def sortByDate (self, store,  REQUEST):
        """
        """
        return self.sortByX('date', store, REQUEST)

    def sortBySize (self, store, REQUEST):
        """
        """
        return self.sortByX('size', store, REQUEST)        

    def sortByFrom (self, store, REQUEST):
        """
        """
        return self.sortByX('from', store, REQUEST)        

    def index(self, store, REQUEST):
        """
        """
        return REQUEST['RESPONSE'].redirect('%s?skin=Folder' % store.getParent(REQUEST).getURL(REQUEST))
    
    def check(self, store, REQUEST):
        """
        """
        store.update(REQUEST)
        return REQUEST['RESPONSE'].redirect("%s?skin=Folder" % (store.getURL(REQUEST)))

    def about(self, store, REQUEST):
        """
        """
        return 'about NOT IMPLEMENTED'

    def help(self, store, REQUEST):
        """
        """
        return 'help NOT IMPLEMENTED'

    def configure(self, store, REQUEST):
        """
        """
        return 'configure NOT IMPLEMENTED'


    def composeMessage(self, store, REQUEST):
        """
        """
        RESPONSE = REQUEST['RESPONSE']
        # Ensure taht NewMessage isn't cached..
        newmessage = store.getParents(REQUEST)[-1].getStore('temp', REQUEST).getStore('NewMessage', REQUEST, 1)
        url = "%s/temp/NewMessage?skin=Compose" % (store.getParents(REQUEST)[-1].getURL(REQUEST))
        REQUEST.close()
        RESPONSE.redirect(url)
        return 'Redirecting for the greater good'

    def addressbooks(self, store, REQUEST):
        """
        """
        return 'addressbooks NOT IMPLEMENETED'


    def configure (self, store, REQUEST):
        """
        """
        return 'configure NOT IMPLEMENETED'
    
    def manage_folders (self, store, REQUEST):
        """
        """
        return 'manage_folders NOT IMPLEMENTED'


    def getFolderList(self, store, REQUEST):
        """
        """
        #store.setFilter('multipart/x-directory', REQUEST)
        top = store.getParents(REQUEST)[-1]
        retVal =  self.getFolders(top, store.getParents(REQUEST)[-1].getURL(REQUEST), 0, REQUEST)
        return retVal

    def getFolders(self, store, parStr, spacing, REQUEST):
        """
        """
        retVal = []
        store.setFilter('multipart/x-directory', REQUEST)        
        spaces = ''
        for i in range(spacing):
            spaces = spaces + '&nbsp;'
        substores = store.getStores(REQUEST)
        treestr = ''
        depth = 0
        for each in substores:
            depth = depth + 1
            if spacing > 1:
                treestr = spaces + '+&nbsp;&nbsp;'
            retVal = retVal + [('%s/%s' % (parStr, each.id), '%s%s' % (treestr, each.id))] + self.getFolders(each, "%s/%s" % (parStr, each.id), spacing + 3, REQUEST)
        return retVal


    def check(self, store, REQUEST):
        """
        """
        return REQUEST['RESPONSE'].redirect('%s?skin=Folder' % store.getURL(REQUEST))

    def replyMessage(self, store, REQUEST):
        """
        """
        RESPONSE = REQUEST['RESPONSE']
        # Ensure taht NewMessage isn't cached..
        newmessage = store.getParents(REQUEST)[-1].getStore('temp', REQUEST).getStore('NewMessage', REQUEST, 1)
        if store.getHeader('reply-to', REQUEST) != '':
            newmessage.setHeader('to', store.getHeader('reply-to', REQUEST), REQUEST)
        else:
            newmessage.setHeader('to', store.getHeader('from', REQUEST), REQUEST)
        if string.upper(store.getHeader('subject', REQUEST)[:2]) == 'RE':
            newmessage.setHeader('subject', store.getHeader('subject', REQUEST), REQUEST)
        else:
            newmessage.setHeader('subject', "RE: %s" % store.getHeader('subject', REQUEST), REQUEST)
        if store.getHeader('Message-ID', REQUEST) != '':
            newmessage.setHeader('In-Reply-To', store.getHeader('Message-ID', REQUEST), REQUEST)
            newmessage.setHeader('References', store.getHeader('Message-ID', REQUEST) + ' ' + 
                                 store.getHeader('References', REQUEST), REQUEST)
        newmessage.setHeader('X-Mailer', 'NotMail v0.1.37', REQUEST)

        data = 'At %s you wrote\n' % (store.getHeader('Date', REQUEST))
        
        if store.getMIMEMajorType(REQUEST) == 'MULTIPART':
            for message in store.getStores(REQUEST):
                if message.getMIMEType(REQUEST) == 'TEXT/PLAIN':
                    data = data + string.join(map(lambda line: '> %s' %
                                                  line, string.split(message.getData(REQUEST), '\n')), '\n')
                else:
                    data = '%s\n<<%s>>' % (data, message.getDescription(REQUEST))
        
        elif store.getMIMEType(REQUEST) == 'TEXT/PLAIN':
            data = data + string.join(map(lambda line: '> %s' %
                                          line, string.split(store.getData(REQUEST), '\n')), '\n')
        else:
            data = '%s\n<<%s>>' % (data, store.getDescription(REQUEST))

        newmessage.getStore('1', REQUEST).setData(data, REQUEST)
        url = "%s/temp/NewMessage?skin=Compose" % (store.getParents(REQUEST)[-1].getURL(REQUEST))
        get_transaction().commit()
        REQUEST.close()
        RESPONSE.redirect(url)
        return 'Redirecting for the greater good'

    def replyAllMessage(self, store, REQUEST):
        """
        """
        RESPONSE = REQUEST['RESPONSE']
        # Ensure taht NewMessage isn't cached..
        newmessage = store.getParents(REQUEST)[-1].getStore('temp', REQUEST).getStore('NewMessage', REQUEST, 1)
        if store.getHeader('reply-to', REQUEST) != '':
            newmessage.setHeader('to', store.getHeader('reply-to', REQUEST), REQUEST)
        else:
            newmessage.setHeader('to', store.getHeader('from', REQUEST), REQUEST)
        newmessage.setHeader('Cc', string.join([store.getHeader('to', REQUEST), store.getHeader('cc', REQUEST)], ','),REQUEST)
        if string.upper(store.getHeader('subject', REQUEST)[:2]) == 'RE':
            newmessage.setHeader('subject', store.getHeader('subject', REQUEST), REQUEST)
        else:
            newmessage.setHeader('subject', "RE: %s" % store.getHeader('subject', REQUEST), REQUEST)
        if store.getHeader('Message-ID', REQUEST) != '':
            newmessage.setHeader('In-Reply-To', store.getHeader('Message-ID', REQUEST), REQUEST)
            newmessage.setHeader('References', store.getHeader('Message-ID', REQUEST) + ' ' + 
                                 store.getHeader('References', REQUEST), REQUEST)
        newmessage.setHeader('X-Mailer', 'NotMail v0.1.37', REQUEST)

        data = 'At %s you wrote\n' % (store.getHeader('Date', REQUEST))
        
        if store.getMIMEMajorType(REQUEST) == 'MULTIPART':
            for message in store.getStores(REQUEST):
                if message.getMIMEType(REQUEST) == 'TEXT/PLAIN':
                    data = data + string.join(map(lambda line: '> %s' %
                                                  line, string.split(message.getData(REQUEST), '\n')), '\n')
                else:
                    data = '%s\n<<%s>>' % (data, message.getDescription(REQUEST))
        
        elif store.getMIMEType(REQUEST) == 'TEXT/PLAIN':
            data = data + string.join(map(lambda line: '> %s' %
                                          line, string.split(store.getData(REQUEST), '\n')), '\n')
        else:
            data = '%s\n<<%s>>' % (data, store.getDescription(REQUEST))

        newmessage.getStore('1', REQUEST).setData(data, REQUEST)
        url = "%s/temp/NewMessage?skin=Compose" % (store.getParents(REQUEST)[-1].getURL(REQUEST))
        get_transaction().commit()
        REQUEST.close()
        RESPONSE.redirect(url)
        return 'Redirecting for the greater good'

    def deleteCurrentMessage(self, store, REQUEST):
        """ """
        store.getParent(REQUEST).deleteMessage(store, REQUEST)
        return REQUEST['RESPONSE'].redirect("%s?skin=Folder" % (store.getParent(REQUEST).getURL(REQUEST)))

    def next_message(self, store, REQUEST):
        """ """
        return REQUEST['RESPONSE'].redirect('%s?skin=Message' % (store.getParent(REQUEST).getNext(store, REQUEST).getURL(REQUEST)))

    def prev_message(self, store, REQUEST):
        """ """
        return REQUEST['RESPONSE'].redirect('%s?skin=Message' % (store.getParent(REQUEST).getPrev(store, REQUEST).getURL(REQUEST)))

    def addSendAddrBook(self, store, REQUEST):
        """
        """
        return 'addSendAddrBook NOT IMPLEMENETED'

    def about(self, store, REQUEST):
        """
        """
        return 'about NOT IMPLEMENETED'

    def help(self, store, REQUEST):
        """
        """
        return 'help NOT IMPLEMENETED'

    def moveCurrentMessage(self, store, REQUEST):
        """ """
        top = store.getParents(REQUEST)[-1]
        for each in string.split(REQUEST.form['dest'][(len(top.getURL(REQUEST)))+1:], '/'):
            top = top.getStore(each, REQUEST)
        store.getParent(REQUEST).moveMessage(store, top, REQUEST)
        return REQUEST['RESPONSE'].redirect("%s?skin=Message" % (store.getURL(REQUEST)))

    def copyCurrentMessage(self, store, REQUEST):
        """ """
        top = store.getParents(REQUEST)[-1]
        for each in string.split(REQUEST.form['dest'][(len(top.getURL(REQUEST)))+1:], '/'):
            top = top.getStore(each, REQUEST)
        store.getParent(REQUEST).copyMessage(store, top, REQUEST)
        return REQUEST['RESPONSE'].redirect("%s?skin=Message" % (store.getURL(REQUEST)))

    def forwardMessage(self, store, REQUEST):
        """
        """
        return "forwardMessage NOT IMPLEMENTED"
    
    def getMIMEHandler(self, store, REQUEST):
        skin =  "%s%sSkin" %( string.capitalize(store.getMIMEMajorType(REQUEST)) , string.capitalize(store.getMIMEMinorType(REQUEST)))
        major = string.capitalize(store.getMIMEMajorType(REQUEST))
        minor =  string.capitalize(store.getMIMEMinorType(REQUEST))
        # TODO: Improve skin determination based on:
        # Current _theme_
        # Download method (imap, ftp, webdav, wap, http etc)
        # Broswer (although this is kinda ugly IMNSHO)
        # Try and get MajorMinorSkin or MajorDefaultSkin _or_ DefaultSkin

        if hasattr(self, "%s%s" % (major, minor)):
            return getattr(self, "%s%s" % (major, minor))
        elif hasattr(self, "%sDefault" % major):
            return getattr(self,  "%sDefault" % major)        
        else:
            return getattr(self,  "ApplicationOctet_Stream")

    def ApplicationOctet_Stream(self, store, REQUEST):
        fileName = store.getFileName(REQUEST)
        url = store.getURL(REQUEST)[:-1]
        url2 = string.join(string.split(url, '/')[:-1], '/') + '/' + fileName
        if url2[0] == '/': url2 = url2[1:]
        return 'Attachment: <A HREF="%s">%s</a> (%s)' % (store.getURL(REQUEST), store.getDescription(REQUEST), store.getMIMEType(REQUEST))

    ApplicationDefault = ApplicationOctet_Stream
    
    def ImageDefault(self, store, REQUEST):
        fileName = store.getFileName(REQUEST)
        url = store.getURL(REQUEST)[:-1]
        url2 = string.join(string.split(url, '/')[:-1], '/') + '/' + fileName
        if url2[0] == '/': url2 = url2[1:]
        return '<A HREF="%s"><IMG SRC="%s" ALT="%s"></a>' % (store.getURL(REQUEST), store.getURL(REQUEST),
                                                             store.getDescription(REQUEST))





    def TextPlain(self, store, REQUEST):
        return '<pre> %s </pre>' % self.setMaxWidth(store.getData(REQUEST), 80)

    def TextHtml(self, store, REQUEST):
        blah = HTML2Body()
        blah.feed(store.getData(REQUEST))
        blah.close()
        return '%s' % blah.getBody() # store.getData(REQUEST)
    
    TextDefault = TextPlain


    def MultipartMixed(self, store, REQUEST):
        result = ''
        for newMessage in store.getStores(REQUEST):
            newHandler = self.getMIMEHandler(newMessage, REQUEST)
            result = "%s%s<BR><HR>" % (result, newHandler(newMessage, REQUEST))
        return  result

    def MultipartDigest(self, store, REQUEST):
        result = ''
        for newMessage in store.getStores(REQUEST):
            result = "%s%s<BR><HR>" % (result, self.MessageRfc822(newMessage, REQUEST))
        return  result


    def MultipartAlternative(self, store, REQUEST):
        useHandler = ''
        useMessage = ''
        for newMessage in store.getStores(REQUEST):
            newHandler = self.getMIMEHandler(newMessage, REQUEST)
            if hasattr(self,  string.capitalize(newMessage.getMIMEMajorType(REQUEST)) +
                       string.capitalize(newMessage.getMIMEMinorType(REQUEST))):
                useHandler = self.getMIMEHandler(newMessage, REQUEST)
                useMessage = newMessage
            elif newMessage.id == 1:
                useHandler = self.getMIMEHandler(newMessage, REQUEST)
                useMessage = newMessage
                break
            else:
                break
        result = "%s" % useHandler(useMessage, REQUEST)
        return result


    MultipartDefault = MultipartMixed


    def MessageRfc822(self, store, REQUEST):
        newMessage = store.getMessageRfc(REQUEST)
        newHandler = self.getMIMEHandler(newMessage, REQUEST)
        headerDisp = ''
        for name in ('To', 'From', 'Cc', 'Date', 'Subject'):
            if newMessage.getHeader(name, REQUEST) != '':
                headerDisp = headerDisp + '<B>%s:</B>%s<BR>' % (name, newMessage.getHeader(name, REQUEST))
        result = '<TABLE WIDTH=100%%><TR><TD BGCOLOR=#fff7e0><PRE>%s</PRE></TD></TR><TR><TD>%s</TD></TR></TABLE>' % ( headerDisp, newHandler(newMessage, REQUEST))
        return  result


    def setMaxWidth(self, stuff, width):
        """
        """
        stuff = string.expandtabs(stuff)
        inStr = cStringIO.StringIO(stuff)
        retVal = ''
        each = inStr.readline()
        while each:
            each = filter(lambda l: ord(l) != 13 and ord(l) != 10, each)
            while len(each) > (width + 1):
                retVal = '%s%s+\n' % (retVal, each[:width])
                each = each[width:]
            retVal = '%s%s\n' % (retVal, each)
            each = inStr.readline()
        inStr.close()
        return html_quote(retVal)


    def sendMessage(self, store, REQUEST):
        """
        """
        # Store message in send-messages and in mailhost...
        store.setHeader('To', REQUEST.form['to'], REQUEST)
        store.setHeader('Cc', REQUEST.form['cc'], REQUEST)
        store.setHeader('Subject', REQUEST.form['subject'], REQUEST)
        store.getStore('1', REQUEST).setData(REQUEST.form['body'], REQUEST)
        mailhost = store.getParents(REQUEST)[-1].getStore('smtp', REQUEST)
        mailhost.addStore(store, REQUEST)
        parentStore = store.getParents(REQUEST)[-1]
        REQUEST['RESPONSE'].redirect("%s?skin=Folder" % parentStore.getStore(parentStore.defaultStore, REQUEST).getStore('inbox', REQUEST).getURL(REQUEST))
        return 'Redirecting for the greater good'

    def sendAttachment(self, store, REQUEST):
        """
        """
        #RESPONSE = REQUEST['RESPONSE']
        if REQUEST.form['attach'].filename != '':
            att = FileMessage.FileMessage(REQUEST.form['attach'])
            store.addStore(att, REQUEST)
        store.setHeader('To', REQUEST.form['to'], REQUEST)
        store.setHeader('Cc', REQUEST.form['cc'], REQUEST)
        store.setHeader('Subject', REQUEST.form['subject'], REQUEST)
        store.getStore('1', REQUEST).setData(REQUEST.form['body'], REQUEST)
        url = "%s?skin=Compose" % (store.getURL(REQUEST))
        #REQUEST.close()
        #RESPONSE.redirect(url)
        REQUEST['store'] = store
        return self.Compose(self, REQUEST)
        return 'Redirecting for the greater good!'

    def defaultDocFile(self, id, title, file):
           """ Adds a Document object read from disk
           
           Reads a dtml file from the NotMail directory and 
           insterts it into a fresh Document object.  Used
           during the initialization phase of new NotMail	
           objects to load in default information.
           Contributed by Amos Latteier.
           """
           
           f=open('%s/Products/ObsidianSkin/%s.dtml' 
                  % (SOFTWARE_HOME, file))
           # Jim suggested below, but it doesn't work I need to RTFS I guess...
           # d = package_home(globals())
           # f=open(d + '%s.dtml' % file)
           file=f.read()
           f.close()
           self.manage_addDocument(id, title, file)

    def refresh_docs(self, REQUEST=None):
       """ refresh documents from disk (for debug purposes) """
       
       for id,title in self.defaultDocs:
           try:
               self._delObject(id)
           except:
               pass
           try:
               self.defaultDocFile(id, title, id)
           except:
               pass

