__doc__ = """TempStore initialization module.  """

__version__ = '0.1' # Anything more and it'd be Interesting.  

import TempStore

def initialize(context): 
    
    try: 
        context.registerClass(
            TempStore.TempStore, 
            constructors = (
                TempStore.manage_addTempStoreForm,
                TempStore.manage_addTempStore),    
            icon = 'item.gif' 
            )
       
    except:
        import sys, traceback, string
        type, val, tb = sys.exc_info()
        sys.stderr.write(string.join(traceback.format_exception(type, val, tb), ''))
        del type, val, tb




